class Typewriter {
    constructor(element) {
        this.element = element;
        this.words = JSON.parse(element.getAttribute('data-text'));
        this.wait = parseInt(element.getAttribute('data-wait') || 3000);
        this.currentWord = 0;
        this.txt = '';
        this.isDeleting = false;
        this.type();
    }

    type() {
        const current = this.currentWord % this.words.length;
        const fullTxt = this.words[current];

        if (this.isDeleting) {
            this.txt = fullTxt.substring(0, this.txt.length - 1);
        } else {
            this.txt = fullTxt.substring(0, this.txt.length + 1);
        }

        this.element.innerHTML = `<span class="typewriter-text">${this.txt}</span>`;

        let typeSpeed = 100;

        if (this.isDeleting) {
            typeSpeed /= 2;
        }

        if (!this.isDeleting && this.txt === fullTxt) {
            typeSpeed = this.wait;
            this.isDeleting = true;
        } else if (this.isDeleting && this.txt === '') {
            this.isDeleting = false;
            this.currentWord++;
            typeSpeed = 500;
        }

        setTimeout(() => this.type(), typeSpeed);
    }
}

// Initialisation immédiate
document.addEventListener('DOMContentLoaded', () => {
    const elements = document.querySelectorAll('.typewriter');
    elements.forEach(element => new Typewriter(element));
});
